////////////////////////////////////////////////////////////////
// ライフゲームガジェット
//   Copyright (C) 2008 - 2012 AAOh inc.
////////////////////////////////////////////////////////////////

/**
 * @fileOverview ライフゲームガジェット
 * @author       $Author: fujishiro $
 */

(function () {
/**
 * lifegame。
 *
 * @namespace
 */
lifegame = {
}
})();

(function () {
/**
 * Control。
 *
 * @constructor
 */
lifegame.Control = aaoh.kaze.Gadget.extend(
	aaoh.sora.ControlEx, function() {
	// Application名。
	this.APP_NAME    = 'lifegame';
	this.APP_VERSION = '2.6.0';

	// Windowサイズ。
	this.WINDOW_ONDOCK_WIDTH         = 130 +  0;
	this.WINDOW_ONDOCK_HEIGHT        = 130 + 12;
	this.WINDOW_UNDOCK_WIDTH         = 210 +  0;
	this.WINDOW_UNDOCK_HEIGHT        = 210 + 12;
	this.WINDOW_ONDOCK_MOBILE_WIDTH  = this.WINDOW_ONDOCK_WIDTH;
	this.WINDOW_ONDOCK_MOBILE_HEIGHT = this.WINDOW_ONDOCK_HEIGHT;
	this.WINDOW_UNDOCK_MOBILE_WIDTH  = this.WINDOW_ONDOCK_MOBILE_WIDTH;
	this.WINDOW_UNDOCK_MOBILE_HEIGHT = this.WINDOW_ONDOCK_MOBILE_HEIGHT;
	this.WINDOW_OPTION_WIDTH         = 250 +  0;
	this.WINDOW_OPTION_HEIGHT        = 250 + 12;
	this.WINDOW_OPTION_MOBILE_WIDTH  = 230 +  0;
	this.WINDOW_OPTION_MOBILE_HEIGHT = 160 + 12;

	// セルサイズ
	this.ONDOCK_CELL_ROW_SIZE = 18;
	this.ONDOCK_CELL_COL_SIZE = 20;
	this.UNDOCK_CELL_ROW_SIZE = this.ONDOCK_CELL_ROW_SIZE;
	this.UNDOCK_CELL_COL_SIZE = this.ONDOCK_CELL_COL_SIZE;

	this.MAX_GEN_CNT  = 1000;                      // 表示最大生存世代
	this.LST_INTERVAL = new Array(100, 500, 1000); // インターバル(msec)

	// パターン
	this.PTN = new Array();

	// ブロック
	this.PTN['0'] = new Array(
		null,
		null,
		null,
		null,
		new Array(false, false, false, false, false, true, true, false, false, true, true, false, false, true, true),
		new Array(false, false, false, false, false, true, true, false, false, true, true, false, false, true, true),
		null,
		null,
		new Array(false, false, false, false, false, true, true, false, false, true, true, false, false, true, true),
		new Array(false, false, false, false, false, true, true, false, false, true, true, false, false, true, true),
		null,
		null,
		new Array(false, false, false, false, false, true, true, false, false, true, true, false, false, true, true),
		new Array(false, false, false, false, false, true, true, false, false, true, true, false, false, true, true)
	);

	// ブリンカー
	this.PTN['1'] = new Array(
		null,
		null,
		null,
		null,
		new Array(false, false, false, true, true, true, false, false, true, true, true, false, false, true, true, true),
		null,
		null,
		null,
		null,
		new Array(false, false, false, true, true, true, false, false, true, true, true, false, false, true, true, true),
		null,
		null,
		null,
		null,
		new Array(false, false, false, true, true, true, false, false, true, true, true, false, false, true, true, true)
	);

	// グライダー
	this.PTN['2'] = new Array(
		null,
		null,
		null,
		null,
		null,
		null,
		null,
		new Array(false, false, false, false, false, false, false, false, false, true,  false),
		new Array(false, false, false, false, false, false, false, false, false, false, true),
		new Array(false, false, false, false, false, false, false, false, true,  true,  true)
	);

	// ダイハード
	this.PTN['3'] = new Array(
		null,
		null,
		null,
		null,
		null,
		null,
		null,
		new Array(false, false, false, false, false, false, false, false, false, false, false, false, true,  false),
		new Array(false, false, false, false, false, false, true,  true,  false, false, false, false, false, false),
		new Array(false, false, false, false, false, false, false, true,  false, false, false, true,  true,  true)
	);

	// 繁殖型1
	this.PTN['4'] = new Array(
		null,
		null,
		null,
		null,
		null,
		null,
		new Array(false, false, false, false, false, false, false, false, false, false, false, false, true,  false),
		new Array(false, false, false, false, false, false, false, false, false, false, true,  false, true,  true),
		new Array(false, false, false, false, false, false, false, false, false, false, true,  false, true,  false),
		new Array(false, false, false, false, false, false, false, false, false, false, true,  false, false, false),
		new Array(false, false, false, false, false, false, false, false, true,  false, false, false, false, false),
		new Array(false, false, false, false, false, false, true,  false, true,  false, false, false, false, false)
	);

	// copyright
	this.LST_IMG_NM.push('imgCopilot');
	this.LST_LNK_NM.push('lnkCopilot');
	this.LST_URL['imgCopilot'] = 'http://copilot.jp/';
	this.LST_URL['lnkCopilot'] = 'http://copilot.jp/';
})
})();

(function () {
/**
 * Model。
 *
 * @constructor
 */
lifegame.Model = aaoh.kaze.Gadget.extend(
	aaoh.sora.ModelEx, function() {
	this.data.type        = '1';
	this.data.numInterval = 500;
	this.data.ptnDef      = '4';
});
	/**
	 * 設定情報の読込み(iGoogle)。
	 */
	lifegame.Model.prototype.
	readDataForIGoogle = function() {
		var type        = aaoh.sora.App.control.storage.readString('type');
		var numInterval = aaoh.sora.App.control.storage.readString('numInterval');
		var ptnDef      = aaoh.sora.App.control.storage.readString('ptnDef');

		if (type != null) {
			this.data.type = type;
		}
		if (numInterval > 0) {
			this.data.numInterval = numInterval;
		}
		if (ptnDef != null) {
			this.data.ptnDef = ptnDef;
		}
	}

	/**
	 * 設定情報の書込み(iGoogle)。
	 */
	lifegame.Model.prototype.
	writeDataForIGoogle = function() {
		aaoh.sora.App.control.storage.writeString(
			'type', this.data.type
		);
		aaoh.sora.App.control.storage.writeString(
			'numInterval', this.data.numInterval
		);
		aaoh.sora.App.control.storage.writeString(
			'ptnDef', this.data.ptnDef
		);
	}
})();

(function () {
/**
 * App。
 *
 * @namespace
 */
aaoh.sora.App = {
	control: new lifegame.Control(),
	model:   new lifegame.Model(),
	main:    null,
	option:  null,

	/**
	 * 初期化。
	 *
	 * @param {String} target 初期化するターゲット
	 */
	init: function(target) {
		if (
			target != null && target == aaoh.sora.App.control.MAIN_NM
		) {
			aaoh.sora.App.main   = new lifegame.Main();
			aaoh.sora.App.option = null;

		} else if (
			target != null && target == aaoh.sora.App.control.OPTION_NM
		) {
			aaoh.sora.App.main   = null;
			aaoh.sora.App.option = new lifegame.Option();

		} else {
			aaoh.sora.App.main   = new lifegame.Main();
			aaoh.sora.App.option = new lifegame.Option();
		}

		// バージョンチェックを行う
		aaoh.sora.App.control.FLG_UPDATE = true;

		aaoh.sora.App.control.init();
	}
}
})();
